package bfv.hardware;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

/**
 * Created by FlyingAl on 15/03/14.
 */
public class  HardwareSettingField extends JPanel implements FocusListener, ActionListener {

    private JLabel infoLabel;
    private JTextField field;
    private JCheckBox box;

    private HardwareParameter parameter;

    public HardwareSettingField(HardwareParameter parameter) {
        this.parameter = parameter;



        this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS ));
        infoLabel = new JLabel(parameter.getName());
        infoLabel.setToolTipText(parameter.getName() + ": " + parameter.getMessage(false));
        infoLabel.setPreferredSize(new Dimension(170, 20));
        infoLabel.setMaximumSize(new Dimension(170, 20));
        this.add(infoLabel);
        this.add(Box.createHorizontalGlue());

        if(parameter.getType() == HardwareParameter.TYPE_BOOLEAN){
            box = new JCheckBox();
            box.setSelected(parameter.getBooleanValue());
            box.addActionListener(this);
            box.setEnabled(false);

            this.add(box);


        }
        else if(parameter.getType() == HardwareParameter.TYPE_INTLIST){

        }
        else{
            field = new JTextField(10);
            //field.setMaximumSize(new Dimension(2000, 24));
            field.setHorizontalAlignment(JTextField.CENTER);
            field.setText(parameter.getValue());
            field.setToolTipText(parameter.getName() + ": " + parameter.getMinMaxMessage());
            field.addFocusListener(this);
            field.addActionListener(this);
            field.setBackground(Color.GRAY);

            field.getDocument().addDocumentListener(new DocumentListener() {
              public void changedUpdate(DocumentEvent e) {

                change();
              }
              public void removeUpdate(DocumentEvent e) {

                  change();
              }
              public void insertUpdate(DocumentEvent e) {

                  change();
              }

              public void change() {
                 field.setBackground(Color.YELLOW);
              }
            });
            field.setEnabled(false);
            this.add(Box.createHorizontalGlue());
            this.add(field);
        }

        parameter.setField(this);
    }

    public void baseValueUpdated(){
        if(field!= null){
            field.setText(parameter.getValue());
            field.setBackground(Color.LIGHT_GRAY);

        }

        if(box != null){

            box.setSelected(parameter.getBooleanValue());
        }


    }

    public void setEnabled(boolean enabled){

        if(field!= null){
           field.setEnabled(true);
           field.setBackground(Color.LIGHT_GRAY);

       }

       if(box != null){

           box.setEnabled(true);
       }

    }

    public void actionPerformed(ActionEvent e) {
        if(field != null){
            String newValue = field.getText();
            parameter.setValueFromDialog(newValue);

        } 
        if(box != null){
            boolean newValue = box.isSelected();
            parameter.setValueFromDialog("" + newValue);

        }

    }

    public void focusGained(FocusEvent e) {


    }

    public void focusLost(FocusEvent e) {
        if(field!= null){
            String newValue = field.getText();
            if(!newValue.equals(parameter.getValue())){
                parameter.setValueFromDialog(newValue);
            }


        }

        if(box!= null){

            parameter.setValueFromDialog(box.isSelected() + "");

        }

    }
}
