/*
 BlueFlyVario flight instrument - http://www.alistairdickie.com/blueflyvario/
 Copyright (C) 2011-2012 Alistair Dickie

 BlueFlyVario is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 BlueFlyVario is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with BlueFlyVario.  If not, see <http://www.gnu.org/licenses/>.
 */

package test;

/**
 * This class is developed from code released in the public domain here:
 *   https://code.google.com/p/pressure-altimeter/
 */
public class AlphaBetaFilter {
        // The state we are tracking, namely:
        private double x_abs;  // The absolute value of x.
        private double x_vel;  // The rate of change of x.

        private double x_abs1;
        private double x_vel1;




        public void update(double z_abs, double alpha, double beta, double dt) {

                // Update state estimate.
                x_abs = x_abs1 + (x_vel1 * dt);
                x_vel = x_vel1;
                double y = z_abs - x_abs;
                x_abs += alpha * y;
                x_vel += (beta * y)/dt;

                x_abs1 = x_abs;
                x_vel1 = x_vel;





        }

        // Getters for the state and its covariance.
        public double getXAbs() { return x_abs; }
        public double getXVel() { return x_vel; }



}